/*
   PKT 2000 data structures for C++
   Created: May 26, 1998 (Beemail v0.359)
   andrius@beemail.com
   http://beemail.com

   ---

   PKT 2000 - Message Transport/Message Base Format
   A Proposed Standard For The BBS Community
   A Sysop's TechNet WorkGroup Document
   Copyright (c) 1996-98 Brent Shellenberg; all rights reserved.

   Revision:       2000.005
   First Draft:    July 3, 1996
   Current Draft:  May 18, 1998
   Contributors:   Brent Shellenberg       brents@shaw.wave.ca
                   Vincent Danen           vdanen@accessweb.com
                   Ramon van der Winkel    ramon@wsd.wline.se
*/

#if !defined(BEE_PKT2000_H)
#define BEE_PKT2000_H

#if !defined(uint8)
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;
#endif

#define P2K_FAttribute_IsKillSent      0x01 // 1 *
#define P2K_FAttribute_IsFileAttached  0x02 // 2
#define P2K_FAttribute_IsFileRequest   0x04 // 3
#define P2K_FAttribute_IsTruncFile     0x08 // 4 *
#define P2K_FAttribute_IsKillFile      0x10 // 5 *
#define P2K_SENDMASK_F                 0x19

#define P2K_RAttribute_IsCrash         0x01
#define P2K_RAttribute_IsHold          0x02
#define P2K_RAttribute_IsDirect        0x04
#define P2K_RAttribute_IsExclusive     0x08
#define P2K_RAttribute_IsImmediate     0x10
#define P2K_SENDMASK_R                 0x00

#define P2K_GAttribute_IsLocal         0x01 // 1 *
#define P2K_GAttribute_IsSent          0x02 // 2 *
#define P2K_GAttribute_IsPrivate       0x04 // 3
#define P2K_GAttribute_IsOrphan        0x08 // 4 *
#define P2K_SENDMASK_G                 0x0B

/* */

struct ANetworkAddress {
   uint16 Zone;
   uint16 Net;
   uint16 Node;
   uint16 Point;
};

#if sizeof(ANetworkAddress) != 8
#error ?!
#endif

/* Packet header */

struct AType2000HeaderV5
{
   uint16 MainHeaderLen;
   uint16 SubHeaderLen;
   ANetworkAddress OrigAddr;
   uint8 OrigDomain[31];
   ANetworkAddress DestAddr;
   uint8 DestDomain[31];
   uint8 Password[9];
   uint8 ProductName[31];
   uint16 PktVersionMajor;
   uint16 PktVersionMinor;
};

#if sizeof(AType2000HeaderV5) != 126
#error ?!
#endif

/* Message header */

struct APakd2000MsgHeadrV5
{
   ANetworkAddress OrigAddr;
   ANetworkAddress DestAddr;
   ANetworkAddress WrittenAddr;
   uint16 Year;
   uint8 Month;
   uint8 Day;
   uint8 Hour;
   uint8 Min;
   uint8 Sec;
   uint8 Sec100;
   uint8 FAttribute;
   uint8 RAttribute;
   uint8 GAttribute;
   uint16 SeenBys;
   uint16 Paths;
   uint32 TextBytes;
};

#if sizeof(APakd2000MsgHeadrV5) != 43
#error ?!
#endif

/* Temporary structure for 'Open strings' */

struct APakd2000MsgHeadrV5x
{
   char ReplyTo[256];
   char MsgId[256];
   char MsgFrom[256];
   char MsgTo[256];
   char MsgSubj[256];
   char EchoArea[256];
};

#endif


